<?php

/**
 * bitpay Gateway Donation Module
 * @author Hamid Yousefi <mails.hamidyousefi@gmail.com>
 * @package engine/modules
 * @version 1.0 Farsi
 * @since Datalife Engine 10.4
 * @link http://dlepersian.com/
 */

defined('DATALIFEENGINE') || exit;

$api = "";

if (filter_input(INPUT_GET, 'action', FILTER_DEFAULT) === 'verify') {
    $trans_id = filter_input(INPUT_POST, 'trans_id', FILTER_DEFAULT);
    $id_get = filter_input(INPUT_POST,'id_get', FILTER_DEFAULT);
    
    $channel = curl_init();
    curl_setopt($channel, CURLOPT_URL, 'https://bitpay.ir/payment/gateway-result-second');
    curl_setopt($channel, CURLOPT_POSTFIELDS, "api=".$api."&id_get=".$id_get."&trans_id=".$trans_id);
    curl_setopt($channel, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($channel, CURLOPT_RETURNTRANSFER, true);
    $result = curl_exec($channel);
    curl_close($channel);
    
    switch($result) {
        case 1:
            $db->query("UPDATE " . PREFIX . "_hypay SET verified = '1', transid = '".$trans_id."' WHERE idget = '".$id_get."'");
            msgbox("تراکنش موفقیت آمیز بود!", "تراکنش شما با موفقیت در سیستم ذخیره شد. شناسه پیگیری شما <strong>".$trans_id."</strong> می باشد.");
            break;
        case -1:
            msgbox("خطا در اتصال به درگاه آنلاین", "API وارد شده با سیستم بیت پی سازگار نیست...");
            break;
        case -2:
            msgbox("خطا در اتصال به درگاه آنلاین", "TRANS_ID ارسال شده نامعتبر است...");
            break;
        case -3:
            msgbox("خطا در اتصال به درگاه آنلاین", "ID_GET ارسالی نامعتبر است...");
            break;
        case -4:
            msgbox("خطا در اتصال به درگاه آنلاین", "چنین تراکنشی در سیستم ثبت نشده است...");
            break;
        default:
            msgbox("خطا در اتصال به درگاه آنلاین", "خطای داخلی سیستم، لطفا در زمان دیگری تلاش فرمائید...");
            break;
    }
}
else {
    $amount = intval(filter_input(INPUT_POST, 'price', FILTER_VALIDATE_INT)) * 10;
    
    $email = $db->safesql(trim(filter_input(INPUT_POST, "email", FILTER_VALIDATE_EMAIL)));

    if ($email === null || $email === "" || empty($email)) {
        msgbox("خطا در پرداخت آنلاین", "آدرس ایمیل وارد شده صحیح نیست! لطفا از یک آدرس صحیح استفاده نمائید...");
    }
    else {
        $channel = curl_init();
        curl_setopt($channel, CURLOPT_URL, 'https://bitpay.ir/payment/gateway-send');
        curl_setopt($channel, CURLOPT_POSTFIELDS, "api=".$api."&amount=".$amount."&redirect=".urlencode($config['http_home_url'].'index.php?do=hypay&action=verify'));
        curl_setopt($channel, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($channel, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($channel);
        curl_close($channel);

        if($result > 0 && is_numeric($result)) {
            $name = $db->safesql(trim(filter_input(INPUT_POST, "name", FILTER_DEFAULT)));
            $mobile = $db->safesql(trim(filter_input(INPUT_POST, "mobile", FILTER_DEFAULT)));
            $why = $db->safesql(trim(filter_input(INPUT_POST, "why", FILTER_DEFAULT)));

            $db->query("INSERT INTO " . PREFIX . "_hypay (`name`, `mobile`, `email`, `message`, `amount`, `date`, `idget`) VALUES ('{$name}', '{$mobile}', '{$email}', '{$why}', '{$amount}', '{$_TIME}', '{$result}')");
            header("Location: https://bitpay.ir/payment/gateway-".$result);
            exit;
        }
        switch($result) {
            case -1:
            msgbox("خطا در اتصال به درگاه آنلاین", "API وارد شده با سیستم بیت پی سازگار نیست...");
            break;
        case -2:
            msgbox("خطا در اتصال به درگاه آنلاین", "مبلغ وارد شده کمتر از 100 تومان است یا معتبر نمی باشد...");
            break;
        case -3:
            msgbox("خطا در اتصال به درگاه آنلاین", "مقدار رشته بازگشتی معتبر نیست...");
            break;
        case -4:
            msgbox("خطا در اتصال به درگاه آنلاین", "درگاهی با اطلاعات وارد شده ثبت نشده یا در حالت انتظار است...");
            break;
            default:
                $error = "خطای داخلی سیستم، لطفا در زمان دیگری تلاش فرمائید...";
                break;
        }
        msgbox("خطا در اتصال به درگاه آنلاین", $error);
    }
}